#!/bin/sh
# -*- coding:utf-8 -*-

# Použijeme-li na prvním nebo druhém řádku kódovací direktivu
# s kódováním # -*- coding:utf-8 -*-, můžeme toto kódování použít v řetězcích a v komentářích!!!

import os.path
import time
import subprocess
import RPi.GPIO as GPIO
from Adafruit_CharLCD import Adafruit_CharLCD

lcd = Adafruit_CharLCD()

GPIO.setmode(GPIO.BCM)
#definujeme GPIO2 (pin3) a GPIO3 (pin 5) jako vstupy, odpor na 3.3V 
GPIO.setup(2, GPIO.IN, pull_up_down=GPIO.PUD_UP)
GPIO.setup(3, GPIO.IN, pull_up_down=GPIO.PUD_UP)
GPIO.setup(4, GPIO.OUT)
GPIO.setup(7, GPIO.OUT)

# úvodní text na display
lcd.clear()
lcd.message('   vyhledavam   ' + '\n' +  'posledni stanici')

# vypneme blikajici LED
GPIO.output(4, 1)
# nahodime pridrzovaci rele zdroje
GPIO.output(7, 1)

channels = [\
        ("http://icecast6.play.cz/cro2-128.mp3", " ", " CRo Dvojka"), \
	("http://icecast3.play.cz:443/frekvence1-128.mp3", " ", " Frekvence 1"), \
        ("http://icecast4.play.cz:443/country128.mp3", " ", " Country radio"), \
	("http://icecast6.play.cz/cesky-impuls.mp3", " ", " Cesky impuls"), \
	("http://icecast2.play.cz/crovysocina128.mp3", " ", "Radio Vysocina"), \
	("http://icecast3.play.cz/radiojihlava128.mp3", " ", " Radio Jihlava") \
        ]


f = open('/home/pi/posledniStaniceCislo', 'r')
idx =int(f.readline())
f.close()
#url = channels[idx][0]
text1 = channels[idx][1]
text2 = channels[idx][2]

time.sleep(2)  # aby se alespoň na chvíli zobrazil předchozí text
lcd.clear()
lcd.message(text1 + '\n' + str(idx+1) + ':' + text2)


while True:
                pocitadlo = 0
		v = int(GPIO.input(2))
		# Button pressed: zobrazime dalsi kanal
                if v <> 1:
			print "Tlacitko zmacknuto zacatek"
			test = os.path.exists('/home/pi/lock')
			# pokud jsem zacal znova mackat a radio jeste neprevzalo nastaveni, smazu lock
			if test == 1:
				os.remove('/home/pi/lock')
			while pocitadlo < 1:
                              	idx = idx + 1
                        	if idx >= len(channels):
                                	idx = 0
				url = channels[idx][0]
				text1 = channels[idx][1]
				text2 = channels[idx][2]
				lcd.clear()
				lcd.message(text1 + '\n' + str(idx+1) + ':' + text2)
				pocitadlo = pocitadlo + 1
				time.sleep(1)
				v2 = int(GPIO.input(2))
				#dokud drzime tlacitko, listujeme
				if v2 <> 1:
					pocitadlo = 0
					print "Tlacitko stale stisknuto, pokracuji v listovani"
			#skoncili jsme listovani, tedy ulozime posledni hodnotu
			f3 = open('/home/pi/posledniStaniceCislo', 'w')
			f3.write(str(idx))
			f3.close()
			f4 = open('/home/pi/posledniStanice', 'w')
			f4.write(url)
			f4.close()
			time.sleep(0.2)
			#a vytvorime lock soubor, aby si to nacetlo radio
			open('/home/pi/lock', 'a').close()
			#vyskocime z cyklu
			v = 1
		time.sleep(0.2)
		#otestujeme stisk vypinaciho kontaktu
		v3 = int(GPIO.input(3))
		if v3 <> 1:
			print "Stisknuto tlacitko pro vypnuti"
			lcd.clear()
			lcd.message('    probiha' + '\n' + ' vypinani radia')
			# zapneme blikajici LED
			GPIO.output(4, 0)
			#GPIO.output(7, 0)
			os.system("sudo shutdown -h now")
